# coding: utf-8

"""
    P2RX API

    API for the P2RX Backend 

    The version of the OpenAPI document: 0.1.DEV-0
    Contact: paul.tindall@rxfoundry.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from rxfoundry.clients.p2rx_api.models.address import Address
from rxfoundry.clients.p2rx_api.models.code import Code
from rxfoundry.clients.p2rx_api.models.patient_external_identifier import PatientExternalIdentifier
from typing import Optional, Set
from typing_extensions import Self

class Patient(BaseModel):
    """
    Patient
    """ # noqa: E501
    uuid: Optional[StrictStr] = None
    last_name: Optional[StrictStr] = None
    first_name: Optional[StrictStr] = None
    middle_name: Optional[StrictStr] = None
    suffix: Optional[StrictStr] = None
    prefix: Optional[StrictStr] = None
    gender: Optional[Code] = None
    date_of_birth: Optional[StrictStr] = None
    home_address: Optional[Address] = None
    primary_phone: Optional[StrictStr] = None
    alternate_phone: Optional[StrictStr] = None
    email: Optional[StrictStr] = None
    external_references: Optional[List[PatientExternalIdentifier]] = None
    __properties: ClassVar[List[str]] = ["uuid", "last_name", "first_name", "middle_name", "suffix", "prefix", "gender", "date_of_birth", "home_address", "primary_phone", "alternate_phone", "email", "external_references"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Patient from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of gender
        if self.gender:
            _dict['gender'] = self.gender.to_dict()
        # override the default output from pydantic by calling `to_dict()` of home_address
        if self.home_address:
            _dict['home_address'] = self.home_address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in external_references (list)
        _items = []
        if self.external_references:
            for _item_external_references in self.external_references:
                if _item_external_references:
                    _items.append(_item_external_references.to_dict())
            _dict['external_references'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Patient from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "uuid": obj.get("uuid"),
            "last_name": obj.get("last_name"),
            "first_name": obj.get("first_name"),
            "middle_name": obj.get("middle_name"),
            "suffix": obj.get("suffix"),
            "prefix": obj.get("prefix"),
            "gender": Code.from_dict(obj["gender"]) if obj.get("gender") is not None else None,
            "date_of_birth": obj.get("date_of_birth"),
            "home_address": Address.from_dict(obj["home_address"]) if obj.get("home_address") is not None else None,
            "primary_phone": obj.get("primary_phone"),
            "alternate_phone": obj.get("alternate_phone"),
            "email": obj.get("email"),
            "external_references": [PatientExternalIdentifier.from_dict(_item) for _item in obj["external_references"]] if obj.get("external_references") is not None else None
        })
        return _obj


