# coding: utf-8

"""
    P2RX API

    API for the P2RX Backend 

    The version of the OpenAPI document: 0.1.DEV-0
    Contact: paul.tindall@rxfoundry.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from rxfoundry.clients.p2rx_api.models.virtual_pharmacy import VirtualPharmacy
from typing import Optional, Set
from typing_extensions import Self

class SurescriptsMessage(BaseModel):
    """
    SurescriptsMessage
    """ # noqa: E501
    uuid: Optional[StrictStr] = None
    virtual_pharmacy: Optional[VirtualPharmacy] = None
    message_id: Optional[StrictStr] = None
    message_type: Optional[StrictStr] = None
    sent_date_time: Optional[datetime] = None
    received_date_time: Optional[datetime] = None
    processed_date_time: Optional[datetime] = None
    message_json: Optional[Dict[str, Any]] = None
    image_pdf: Optional[StrictStr] = None
    image_png: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["uuid", "virtual_pharmacy", "message_id", "message_type", "sent_date_time", "received_date_time", "processed_date_time", "message_json", "image_pdf", "image_png"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SurescriptsMessage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of virtual_pharmacy
        if self.virtual_pharmacy:
            _dict['virtual_pharmacy'] = self.virtual_pharmacy.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SurescriptsMessage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "uuid": obj.get("uuid"),
            "virtual_pharmacy": VirtualPharmacy.from_dict(obj["virtual_pharmacy"]) if obj.get("virtual_pharmacy") is not None else None,
            "message_id": obj.get("message_id"),
            "message_type": obj.get("message_type"),
            "sent_date_time": obj.get("sent_date_time"),
            "received_date_time": obj.get("received_date_time"),
            "processed_date_time": obj.get("processed_date_time"),
            "message_json": obj.get("message_json"),
            "image_pdf": obj.get("image_pdf"),
            "image_png": obj.get("image_png")
        })
        return _obj


